#ifndef INCL_XMLSTREAM_H
#define INCL_XMLSTREAM_H

#define XMLSTREAM_ERROR -1
#define XMLSTREAM_ROOT 0
#define XMLSTREAM_NODE 1
#define XMLSTREAM_CLOSE 2
#define XMLSTREAM_INIT 3

typedef int (*xmlstream_onNode)(thread t, xmlnode x, int type);

/* Wrapper around tstream_start() */
thread xmlstream_new(int fd, xmlstream_onNode evt);

/* Specifies a new xmlnode to serialize to the fd */
int xmlstream_write(thread t, xmlnode x);

/* Special utilities */
xmlnode xmlstream_header(char *namespace, char *to, char *from);
void xmlstream_write_header(thread t, xmlnode x);
void xmlstream_error(thread t, char *err);

/* The onRead callback for the tstream */
void _xmlstream_main(void *arg, void *buffer, int bufsz);

static void _xmlstream_cleanup(void *arg);

#endif

