#include <jabber/jlib.h>

int jlib_init(int log2, char *arg)
{   	
    sigset_t sigs;
    int i, fd;

    /* init pth */
    pth_init();	

    switch(log2)
    {
        case LOG2_NONE:
            log_init((char *)LOG2_STDERR);
            break;
        case LOG2_FILE:
            fd = open(arg, O_WRONLY | O_CREAT);
            if(fd > 0)
                log_init((char *)tstream_new(fd, NULL, NULL));
            else
                log_init((char *)LOG2_STDERR);
            break;
        case LOG2_SYSLOG:
            openlog("Jabber", LOG_PID, LOG_DAEMON);
            log_init((char *)LOG2_SYSLOG);
        default:
            log_init((char *)log2);
            break;
    }
 
    debug("jlib_init");
}                                                                                                                          
