#include <jabber/jlib.h>

#ifdef DEBUG
void debug(const char *msgfmt, ...)
{
	va_list ap;
	static char loghdr[LOGSIZE_HDR];
	static char logmsg[LOGSIZE_TAIL];
	static int size;

	/* XXX: We may want to check the sizes eventually */
	size = snprintf(loghdr, LOGSIZE_HDR, "DEBUG: %s\n", msgfmt);

	va_start(ap, msgfmt);
	size = vsnprintf(logmsg, LOGSIZE_TAIL, loghdr, ap);
    
	_log(logmsg);

	return;
}

void insane(const char *msgfmt, ...)
{
	va_list ap;
	static char loghdr[LOGSIZE_HDR];
	static char logmsg[LOGSIZE_HDR];
	static int size;

	/* XXX: We may want to check the sizes eventually */
	size = snprintf(loghdr, LOGSIZE_HDR, "URNuts: %s\n", msgfmt);

	va_start(ap, msgfmt);
	size = vsnprintf(logmsg, LOGSIZE_TAIL, loghdr, ap);
    
	_log(logmsg);

	return;
}
#endif

void warn(char *zone, const char *msgfmt, ...)
{
	va_list ap;
	static char loghdr[LOGSIZE_HDR];
	static char logmsg[LOGSIZE_HDR];
	static int size;

	/* XXX: We may want to check the sizes eventually */
	size = snprintf(loghdr, LOGSIZE_HDR, "Warning: %s, %s\n", zone, msgfmt);

	va_start(ap, msgfmt);
	size = vsnprintf(logmsg, LOGSIZE_TAIL, loghdr, ap);
    
	_log(logmsg);

	return;
}

void error(char *zone, const char *msgfmt, ...)
{
	va_list ap;
	static char loghdr[LOGSIZE_HDR];
	static char logmsg[LOGSIZE_HDR];
	static int size;

	/* XXX: We may want to check the sizes eventually */
	size = snprintf(loghdr, LOGSIZE_HDR, "ERROR: %s, %s\n", zone, msgfmt);

	va_start(ap, msgfmt);
	size = vsnprintf(logmsg, LOGSIZE_TAIL, loghdr, ap);
    
	_log(logmsg);

	return;
}

void _log(const char *logmsg)
{
	static int log_to=0;

	if(log_to == 0)
	{
		log_to = (int)logmsg;
		printf("Logger set to: %d\n", log_to);
		return;
	}

    switch(log_to)
    {
        case 0:
            printf("%s", logmsg);
            break;
        case LOG2_STDERR:
            fprintf(stderr,"%s", logmsg);
            break;
        case LOG2_SYSLOG:
			syslog(LOG_NOTICE, logmsg);
            break;
        default:
            tstream_write((thread)log_to, (void *)logmsg, sizeof(logmsg));
            break;
    }
	return;
}

